const DIAGONAL_LENGTH = Math.hypot(1280, 720);
const LOCAL_AXIS_LENGTH = 100;

class Gizmos
{
	static DrawGizmos(runtime, player)
	{	
		const x = player.instVars.screen_x;
		const y = player.instVars.screen_y;
		
		const angle = player.angle;
		
		runtime.callFunction("GizmoCanvas.Clear");
		
		Gizmos.drawFieldOfView    (runtime, x, y, angle);
		Gizmos.drawClippingPlane  (runtime, x, y, angle);
		Gizmos.drawPlayerLocalAxis(runtime, x, y, angle);
	}
	
	static drawFieldOfView(runtime, x, y, angle) 
	{	
		runtime.callFunction("GizmoCanvas.AddPolygonPoint", x, y);
		
		runtime.callFunction("GizmoCanvas.AddPolygonPoint",
			x + 1.5 * DIAGONAL_LENGTH * Math.cos(angle - Math.PI / 4),
			y + 1.5 * DIAGONAL_LENGTH * Math.sin(angle - Math.PI / 4)
		);
		
		runtime.callFunction("GizmoCanvas.AddPolygonPoint",
			x + 1.5 * DIAGONAL_LENGTH * Math.cos(angle + Math.PI / 4),
			y + 1.5 * DIAGONAL_LENGTH * Math.sin(angle + Math.PI / 4)
		);
		
		runtime.callFunction("GizmoCanvas.FillPolygon");
		runtime.callFunction("GizmoCanvas.OutlinePolygon");
		runtime.callFunction("GizmoCanvas.ResetPolygon");
	}
	
	static drawClippingPlane(runtime, x, y, angle)
	{
		runtime.callFunction("GizmoCanvas.DrawDashedLine",
			x + DIAGONAL_LENGTH * Math.cos(angle - Math.PI / 2),
			y + DIAGONAL_LENGTH * Math.sin(angle - Math.PI / 2),
			x + DIAGONAL_LENGTH * Math.cos(angle + Math.PI / 2),
			y + DIAGONAL_LENGTH * Math.sin(angle + Math.PI / 2)
		);
	}
	
	static drawPlayerLocalAxis(runtime, x, y, angle)
	{
		runtime.callFunction("GizmoCanvas.DrawLine", x, y,
			x + LOCAL_AXIS_LENGTH * Math.cos(angle),
			y + LOCAL_AXIS_LENGTH * Math.sin(angle),
			0, 0, 100
		);
		
		runtime.callFunction("GizmoCanvas.DrawLine", x, y,
			x + LOCAL_AXIS_LENGTH * Math.cos(angle - Math.PI / 2),
			y + LOCAL_AXIS_LENGTH * Math.sin(angle - Math.PI / 2),
			100, 0, 0
		);
	}
}