class Player extends ISpriteInstance
{
	constructor()
	{ 
		super(); 
		
		// Note that the player's world Z position is represented by the Y position of the marker in the layout. 
		// Thus, 'elevation' represents the player's world Y position.
		this.elevation = 800;
	}
	
	// Translates the player sprite depending on the XYZ input.
	Translate(dt, ix, iy, iz)
	{
		const dx = this.instVars.move_speed * dt *  camera.cache.yaw.sin;
		const dz = this.instVars.move_speed * dt *  camera.cache.yaw.cos;
		
		this.x += dx * iz + dz * ix;
		this.y += dz * iz - dx * ix;
		
		this.elevation += this.instVars.elevate_speed * iy * dt
	}
	
	// Rotates the player sprite counter-clockwise/clockwise depending on the yaw input.
	Rotate(dt, dyaw)
	{
		this.angle += this.instVars.rotate_speed * (Math.PI / 180) * dyaw * dt;
	}
}