class Vertex 
{

	constructor(x, y, z) 
	{ 
		this.world 	    = {'x': x, 'y': y, 'z': z};
		this.translated = {'x': 0, 'y': 0, 'z': 0};
		this.rotated	= {'x': 0, 'y': 0, 'z': 0};
	}
	
	translatePosition() 
	{	
		this.translated.x = this.world.x - camera.world.x;
		this.translated.y = this.world.y - camera.world.y;
		this.translated.z = this.world.z - camera.world.z;
	}
	
	rotatePosition()
	{
		
		// Since the camera will only rotate in the y-axis (yaw), we can hard-code these formulas for X and Z.
		this.rotated.x = this.translated.x * camera.cache.yaw.cos + this.translated.z * -camera.cache.yaw.sin;
		this.rotated.z = this.translated.x * camera.cache.yaw.sin + this.translated.z *  camera.cache.yaw.cos;
		
		this.rotated.y = this.translated.y;
	}
	
	TransformPosition()
	{
		this.translatePosition();
		this.rotatePosition();		
	}
	
	ScreenPosition() 
	{	
		const scale = screen_center.z / this.rotated.z;
		return {
			'x': screen_center.x - this.rotated.x * scale,
			'y': screen_center.y - this.rotated.y * scale,
			'scale': scale
		}
	}
}